﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace University
{
    class Teacher : UniversityCitizen
    {
        private static List<Teacher> _ListOfTeachers = new List<Teacher>();

        public static List<String> ListedTeacherNames
        {
            get
            {
                List<String> teacherNames = new List<String>();
                foreach (Teacher teacher in _ListOfTeachers)
                    teacherNames.Add(teacher.Name);
                return teacherNames;
            }
        }

        private static String GenerateCode(String name)
        {
            Int32 counter = 1;
            String[] nameParts = name.Split(new char[] { ' ' });
            String code = nameParts[1].ToLower()[0] + nameParts[0].ToLower() + "_TH" + counter.ToString(); ;

            foreach (Teacher th in _ListOfTeachers)
            {
                if (code == th.UniversityCode)
                {
                    counter++;
                    code = nameParts[1].ToLower()[0] + nameParts[0].ToLower() + "_TH" + counter.ToString();
                }
            }
            return code;
        }

        public Teacher(String name)
            : base(name)
        {
            UniversityCode = GenerateCode(Name);

            _ListOfTeachers.Add(this);
        }

        public Course CreateCourse(String name)
        {
            Course course = new Course(this, name);
            _Courses.Add(course);
            return course;
        }

        public Course GetCourse(String name)
        {
            foreach (Course course in _Courses)
                if (course.Name == name)
                    return course;
            return null;
        }
    }
}
