﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace University
{
    class Teacher : UniversityCitizen
    {
        public static List<String> ListedTeacherNames
        {
            get
            {
                List<String> teacherNames = new List<String>();
                foreach (UniversityCitizen citizen in _ListOfCitizens)
                    if(citizen is Teacher)
                    teacherNames.Add(citizen.Name);
                return teacherNames;
            }
        }

        public Teacher(String name)
            : base(name)
        {
        }

        public Course CreateCourse(String name)
        {
            Course course = new Course(this, name);
            _Courses.Add(course);
            return course;
        }

        public Course GetCourse(String name)
        {
            foreach (Course course in _Courses)
                if (course.Name == name)
                    return course;
            return null;
        }
    }
}
