﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace University
{
    abstract class UniversityCitizen
    {
        protected static List<UniversityCitizen> _ListOfCitizens = new List<UniversityCitizen>();

        protected static String GenerateCode(String name)
        {
            Int32 counter = 1;
            String[] nameParts = name.Split(new char[] { ' ' });
            String code = nameParts[1].ToLower()[0] + nameParts[0].ToLower() + "_" + counter.ToString(); ;

            foreach (UniversityCitizen uc in _ListOfCitizens)
            {
                if (code == uc.UniversityCode)
                {
                    counter++;
                    code = nameParts[1].ToLower()[0] + nameParts[0].ToLower() + "_" + counter.ToString();
                }
            }
            return code;
        }

        protected List<Course> _Courses;

        public String Name { get; protected set; }
        public String UniversityCode { get; protected set; }

        public List<String> CourseNames
        {
            get
            {
                List<String> courseNames = new List<String>();
                foreach (Course course in _Courses)
                    courseNames.Add(course.Name);
                return courseNames;
            }
        }

        public UniversityCitizen(String name)
        {
            Name = name;
            UniversityCode = GenerateCode(Name);
            _Courses = new List<Course>();

            _ListOfCitizens.Add(this);
        }
    }
}
