﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace University
{
    class Student
    {
        private static List<Student> _ListOfStudents = new List<Student>();

        private static String GenerateCode(String name)
        {
            Int32 counter = 1;
            String[] nameParts = name.Split(new char[] { ' ' });
            String code = nameParts[1].ToLower()[0] + nameParts[0].ToLower() + "_ST" + counter.ToString();

            foreach (Student st in _ListOfStudents)
            {
                if (code == st.UniversityCode)
                {
                    counter++;
                    code = nameParts[1].ToLower()[0] + nameParts[0].ToLower() + "_ST" + counter.ToString();
                }
            }
            return code;
        }

        private List<Course> _Courses;

        public String Name { get; private set; }
        public String UniversityCode { get; private set; }

        public Student(String name)
        {
            Name = name;
            _Courses = new List<Course>();
            UniversityCode = GenerateCode(Name);

            _ListOfStudents.Add(this);
        }

        public void SignForCourse(Course course)
        {
            if (course.AddStudent(this))
                _Courses.Add(course);
        }
    }
}
